use std::sync::Arc;
use std::collections::HashMap;
use std::hash::Hash;
use crate::canvas::*;
use crate::canvas::managed::shader::dynamic_vertex::RuntimeVertexDef;
use crate::canvas::managed::handles::{CanvasTextureHandle, CanvasImageHandle, CanvasFontHandle, Handle};
use crate::canvas::managed::shader::text_shader::GlyphInstance;
use vulkano::pipeline::vertex::Vertex;
use std::any::Any;
use crate::VertexTypes;

/// Trait which may be inherited by objects that wish to be drawn to the screen
pub trait Drawable {
    fn get(&self) -> VertexTypes;
}

/// Accumulator for Vectors of VertexTypes
#[derive(Default)]
pub struct CanvasFrame {
    pub map: Vec<VertexTypes>,
}

impl CanvasFrame {

    /// Push this drawable onto the back of the accumulator
    pub fn draw(&mut self, drawable: &dyn Drawable) {
        self.map.push(drawable.get());
    }
}
